// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.6.1
// source: api/grpc/proto/valid.proto

package types

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ValidateClient is the client API for Validate service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ValidateClient interface {
	Report(ctx context.Context, in *ReportRequest, opts ...grpc.CallOption) (*ReportResponse, error)
}

type validateClient struct {
	cc grpc.ClientConnInterface
}

func NewValidateClient(cc grpc.ClientConnInterface) ValidateClient {
	return &validateClient{cc}
}

func (c *validateClient) Report(ctx context.Context, in *ReportRequest, opts ...grpc.CallOption) (*ReportResponse, error) {
	out := new(ReportResponse)
	err := c.cc.Invoke(ctx, "/NODR.crypto.Validate/Report", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ValidateServer is the server API for Validate service.
// All implementations must embed UnimplementedValidateServer
// for forward compatibility
type ValidateServer interface {
	Report(context.Context, *ReportRequest) (*ReportResponse, error)
	mustEmbedUnimplementedValidateServer()
}

// UnimplementedValidateServer must be embedded to have forward compatible implementations.
type UnimplementedValidateServer struct {
}

func (UnimplementedValidateServer) Report(context.Context, *ReportRequest) (*ReportResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Report not implemented")
}
func (UnimplementedValidateServer) mustEmbedUnimplementedValidateServer() {}

// UnsafeValidateServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ValidateServer will
// result in compilation errors.
type UnsafeValidateServer interface {
	mustEmbedUnimplementedValidateServer()
}

func RegisterValidateServer(s grpc.ServiceRegistrar, srv ValidateServer) {
	s.RegisterService(&Validate_ServiceDesc, srv)
}

func _Validate_Report_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReportRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ValidateServer).Report(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/NODR.crypto.Validate/Report",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ValidateServer).Report(ctx, req.(*ReportRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Validate_ServiceDesc is the grpc.ServiceDesc for Validate service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Validate_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "NODR.crypto.Validate",
	HandlerType: (*ValidateServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Report",
			Handler:    _Validate_Report_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "api/grpc/proto/valid.proto",
}
